from enum import Enum

class StatusCode(Enum):
    # Name    Value       Description
    GOOD = ('0x00000000', 'Operation succeeded')
    INFOTYPE_DATAVALUE = ('0x00000400', '')
    INFOBITS_OVERFLOW = ('0x00000080', '')
    BADUNEXPECTEDERROR = ('0x80010000', 'An unexpected error occurred')
    BADINTERNALERROR = ('0x80020000', 'An internal error occurred as a result of a programming or configuration error')
    BADOUTOFMEMORY = ('0x80030000', 'Not enough memory to complete the operation')
    BADRESOURCEUNAVAILABLE = ('0x80040000', 'An operating system resource is not available')
    BADCOMMUNICATIONERROR = ('0x80050000', 'A low level communication error occurred')
    BADENCODINGERROR = ('0x80060000', 'Encoding halted because of invalid data in the objects being serialized')
    BADDECODINGERROR = ('0x80070000', 'Decoding halted because of invalid data in the stream')
    BADENCODINGLIMITSEXCEEDED = ('0x80080000', 'The message encoding/decoding limits imposed by the stack have been exceeded')
    BADREQUESTTOOLARGE = ('0x80B80000', 'The request message size exceeds limits set by the server')
    BADRESPONSETOOLARGE = ('0x80B90000', 'The response message size exceeds limits set by the client')
    BADUNKNOWNRESPONSE = ('0x80090000', 'An unrecognized response was received from the server')
    BADTIMEOUT = ('0x800A0000', 'The operation timed out')
    BADSERVICEUNSUPPORTED = ('0x800B0000', 'The server does not support the requested service')
    BADSHUTDOWN = ('0x800C0000', 'The operation was cancelled because the application is shutting down')
    BADSERVERNOTCONNECTED = ('0x800D0000', 'The operation could not complete because the client is not connected to the server')
    BADSERVERHALTED = ('0x800E0000', 'The server has stopped and cannot process any requests')
    BADNOTHINGTODO = ('0x800F0000', 'There was nothing to do because the client passed a list of operations with no elements')
    BADTOOMANYOPERATIONS = ('0x80100000', 'The request could not be processed because it specified too many operations')
    BADTOOMANYMONITOREDITEMS = ('0x80DB0000', 'The request could not be processed because there are too many monitored items in the subscription')
    BADDATATYPEIDUNKNOWN = ('0x80110000', 'The extension object cannot be (de)serialized because the data type id is not recognized')
    BADCERTIFICATEINVALID = ('0x80120000', 'The certificate provided as a parameter is not valid')
    BADSECURITYCHECKSFAILED = ('0x80130000', 'An error occurred verifying security')
    BADCERTIFICATEPOLICYCHECKFAILED = ('0x81140000', 'The certificate does not meet the requirements of the security policy')
    BADCERTIFICATETIMEINVALID = ('0x80140000', 'The certificate has expired or is not yet valid')
    BADCERTIFICATEISSUERTIMEINVALID = ('0x80150000', 'An issuer certificate has expired or is not yet valid')
    BADCERTIFICATEHOSTNAMEINVALID = ('0x80160000', 'The HostName used to connect to a server does not match a HostName in the certificate')
    BADCERTIFICATEURIINVALID = ('0x80170000', 'The URI specified in the ApplicationDescription does not match the URI in the certificate')
    BADCERTIFICATEUSENOTALLOWED = ('0x80180000', 'The certificate may not be used for the requested operation')
    BADCERTIFICATEISSUERUSENOTALLOWED = ('0x80190000', 'The issuer certificate may not be used for the requested operation')
    BADCERTIFICATEUNTRUSTED = ('0x801A0000', 'The certificate is not trusted')
    BADCERTIFICATEREVOCATIONUNKNOWN = ('0x801B0000', 'It was not possible to determine if the certificate has been revoked')
    BADCERTIFICATEISSUERREVOCATIONUNKNOWN = ('0x801C0000', 'It was not possible to determine if the issuer certificate has been revoked')
    BADCERTIFICATEREVOKED = ('0x801D0000', 'The certificate has been revoked')
    BADCERTIFICATEISSUERREVOKED = ('0x801E0000', 'The issuer certificate has been revoked')
    BADCERTIFICATECHAININCOMPLETE = ('0x810D0000', 'The certificate chain is incomplete')
    BADUSERACCESSDENIED = ('0x801F0000', 'User does not have permission to perform the requested operation')
    BADIDENTITYTOKENINVALID = ('0x80200000', 'The user identity token is not valid')
    BADIDENTITYTOKENREJECTED = ('0x80210000', 'The user identity token is valid but the server has rejected it')
    BADSECURECHANNELIDINVALID = ('0x80220000', 'The specified secure channel is no longer valid')
    BADINVALIDTIMESTAMP = ('0x80230000', 'The timestamp is outside the range allowed by the server')
    BADNONCEINVALID = ('0x80240000', 'The nonce does appear to be not a random value or it is not the correct length')
    BADSESSIONIDINVALID = ('0x80250000', 'The session id is not valid')
    BADSESSIONCLOSED = ('0x80260000', 'The session was closed by the client')
    BADSESSIONNOTACTIVATED = ('0x80270000', 'The session cannot be used because ActivateSession has not been called')
    BADSUBSCRIPTIONIDINVALID = ('0x80280000', 'The subscription id is not valid')
    BADREQUESTHEADERINVALID = ('0x802A0000', 'The header for the request is missing or invalid')
    BADTIMESTAMPSTORETURNINVALID = ('0x802B0000', 'The timestamps to return parameter is invalid')
    BADREQUESTCANCELLEDBYCLIENT = ('0x802C0000', 'The request was cancelled by the client')
    BADTOOMANYARGUMENTS = ('0x80E50000', 'Too many arguments were provided')
    BADLICENSEEXPIRED = ('0x810E0000', 'The server requires a license to operate in general or to perform a service or operation')
    BADLICENSELIMITSEXCEEDED = ('0x810F0000', 'The server has limits on number of allowed operations / objects')
    BADLICENSENOTAVAILABLE = ('0x81100000', 'The server does not have a license which is required to operate in general or to perform a service or operation')
    GOODSUBSCRIPTIONTRANSFERRED = ('0x002D0000', 'The subscription was transferred to another session')
    GOODCOMPLETESASYNCHRONOUSLY = ('0x002E0000', 'The processing will complete asynchronously')
    GOODOVERLOAD = ('0x002F0000', 'Sampling has slowed down due to resource limitations')
    GOODCLAMPED = ('0x00300000', 'The value written was accepted but was clamped')
    BADNOCOMMUNICATION = ('0x80310000', 'Communication with the data source is defined')
    BADWAITINGFORINITIALDATA = ('0x80320000', 'Waiting for the server to obtain values from the underlying data source')
    BADNODEIDINVALID = ('0x80330000', 'The syntax of the node id is not valid')
    BADNODEIDUNKNOWN = ('0x80340000', 'The node id refers to a node that does not exist in the server address space')
    BADATTRIBUTEIDINVALID = ('0x80350000', 'The attribute is not supported for the specified Node')
    BADINDEXRANGEINVALID = ('0x80360000', 'The syntax of the index range parameter is invalid')
    BADINDEXRANGENODATA = ('0x80370000', 'No data exists within the range of indexes specified')
    BADDATAENCODINGINVALID = ('0x80380000', 'The data encoding is invalid')
    BADDATAENCODINGUNSUPPORTED = ('0x80390000', 'The server does not support the requested data encoding for the node')
    BADNOTREADABLE = ('0x803A0000', 'The access level does not allow reading or subscribing to the Node')
    BADNOTWRITABLE = ('0x803B0000', 'The access level does not allow writing to the Node')
    BADOUTOFRANGE = ('0x803C0000', 'The value was out of range')
    BADNOTSUPPORTED = ('0x803D0000', 'The requested operation is not supported')
    BADNOTFOUND = ('0x803E0000', 'A requested item was not found or a search operation ended without success')
    BADOBJECTDELETED = ('0x803F0000', 'The object cannot be used because it has been deleted')
    BADNOTIMPLEMENTED = ('0x80400000', 'Requested operation is not implemented')
    BADMONITORINGMODEINVALID = ('0x80410000', 'The monitoring mode is invalid')
    BADMONITOREDITEMIDINVALID = ('0x80420000', 'The monitoring item id does not refer to a valid monitored item')
    BADMONITOREDITEMFILTERINVALID = ('0x80430000', 'The monitored item filter parameter is not valid')
    BADMONITOREDITEMFILTERUNSUPPORTED = ('0x80440000', 'The server does not support the requested monitored item filter')
    BADFILTERNOTALLOWED = ('0x80450000', 'A monitoring filter cannot be used in combination with the attribute specified')
    BADSTRUCTUREMISSING = ('0x80460000', 'A mandatory structured parameter was missing or null')
    BADEVENTFILTERINVALID = ('0x80470000', 'The event filter is not valid')
    BADCONTENTFILTERINVALID = ('0x80480000', 'The content filter is not valid')
    BADFILTEROPERATORINVALID = ('0x80C10000', 'An unrecognized operator was provided in a filter')
    BADFILTEROPERATORUNSUPPORTED = ('0x80C20000', 'A valid operator was provided')
    BADFILTEROPERANDCOUNTMISMATCH = ('0x80C30000', 'The number of operands provided for the filter operator was less then expected for the operand provided')
    BADFILTEROPERANDINVALID = ('0x80490000', 'The operand used in a content filter is not valid')
    BADFILTERELEMENTINVALID = ('0x80C40000', 'The referenced element is not a valid element in the content filter')
    BADFILTERLITERALINVALID = ('0x80C50000', 'The referenced literal is not a valid value')
    BADCONTINUATIONPOINTINVALID = ('0x804A0000', 'The continuation point provide is longer valid')
    BADNOCONTINUATIONPOINTS = ('0x804B0000', 'The operation could not be processed because all continuation points have been allocated')
    BADREFERENCETYPEIDINVALID = ('0x804C0000', 'The reference type id does not refer to a valid reference type node')
    BADBROWSEDIRECTIONINVALID = ('0x804D0000', 'The browse direction is not valid')
    BADNODENOTINVIEW = ('0x804E0000', 'The node is not part of the view')
    BADNUMERICOVERFLOW = ('0x81120000', 'The number was not accepted because of a numeric overflow')
    BADSERVERURIINVALID = ('0x804F0000', 'The ServerUri is not a valid URI')
    BADSERVERNAMEMISSING = ('0x80500000', 'No ServerName was specified')
    BADDISCOVERYURLMISSING = ('0x80510000', 'No DiscoveryUrl was specified')
    BADSEMPAHOREFILEMISSING = ('0x80520000', 'The semaphore file specified by the client is not valid')
    BADREQUESTTYPEINVALID = ('0x80530000', 'The security token request type is not valid')
    BADSECURITYMODEREJECTED = ('0x80540000', 'The security mode does not meet the requirements set by the server')
    BADSECURITYPOLICYREJECTED = ('0x80550000', 'The security policy does not meet the requirements set by the server')
    BADTOOMANYSESSIONS = ('0x80560000', 'The server has reached its maximum number of sessions')
    BADUSERSIGNATUREINVALID = ('0x80570000', 'The user token signature is missing or invalid')
    BADAPPLICATIONSIGNATUREINVALID = ('0x80580000', 'The signature generated with the client certificate is missing or invalid')
    BADNOVALIDCERTIFICATES = ('0x80590000', 'The client did not provide at least one software certificate that is valid and meets the profile requirements for the server')
    BADIDENTITYCHANGENOTSUPPORTED = ('0x80C60000', 'The server does not support changing the user identity assigned to the session')
    BADREQUESTCANCELLEDBYREQUEST = ('0x805A0000', 'The request was cancelled by the client with the Cancel service')
    BADPARENTNODEIDINVALID = ('0x805B0000', 'The parent node id does not to refer to a valid node')
    BADREFERENCENOTALLOWED = ('0x805C0000', 'The reference could not be created because it violates constraints imposed by the data model')
    BADNODEIDREJECTED = ('0x805D0000', 'The requested node id was reject because it was either invalid or server does not allow node ids to be specified by the client')
    BADNODEIDEXISTS = ('0x805E0000', 'The requested node id is already used by another node')
    BADNODECLASSINVALID = ('0x805F0000', 'The node class is not valid')
    BADBROWSENAMEINVALID = ('0x80600000', 'The browse name is invalid')
    BADBROWSENAMEDUPLICATED = ('0x80610000', 'The browse name is not unique among nodes that share the same relationship with the parent')
    BADNODEATTRIBUTESINVALID = ('0x80620000', 'The node attributes are not valid for the node class')
    BADTYPEDEFINITIONINVALID = ('0x80630000', 'The type definition node id does not reference an appropriate type node')
    BADSOURCENODEIDINVALID = ('0x80640000', 'The source node id does not reference a valid node')
    BADTARGETNODEIDINVALID = ('0x80650000', 'The target node id does not reference a valid node')
    BADDUPLICATEREFERENCENOTALLOWED = ('0x80660000', 'The reference type between the nodes is already defined')
    BADINVALIDSELFREFERENCE = ('0x80670000', 'The server does not allow this type of self reference on this node')
    BADREFERENCELOCALONLY = ('0x80680000', 'The reference type is not valid for a reference to a remote server')
    BADNODELETERIGHTS = ('0x80690000', 'The server will not allow the node to be deleted')
    UNCERTAINREFERENCENOTDELETED = ('0x40BC0000', 'The server was not able to delete all target references')
    BADSERVERINDEXINVALID = ('0x806A0000', 'The server index is not valid')
    BADVIEWIDUNKNOWN = ('0x806B0000', 'The view id does not refer to a valid view node')
    BADVIEWTIMESTAMPINVALID = ('0x80C90000', 'The view timestamp is not available or not supported')
    BADVIEWPARAMETERMISMATCH = ('0x80CA0000', 'The view parameters are not consistent with each other')
    BADVIEWVERSIONINVALID = ('0x80CB0000', 'The view version is not available or not supported')
    UNCERTAINNOTALLNODESAVAILABLE = ('0x40C00000', 'The list of references may not be complete because the underlying system is not available')
    GOODRESULTSMAYBEINCOMPLETE = ('0x00BA0000', 'The server should have followed a reference to a node in a remote server but did not. The result set may be incomplete')
    BADNOTTYPEDEFINITION = ('0x80C80000', 'The provided Nodeid was not a type definition nodeid')
    UNCERTAINREFERENCEOUTOFSERVER = ('0x406C0000', 'One of the references to follow in the relative path references to a node in the address space in another server')
    BADTOOMANYMATCHES = ('0x806D0000', 'The requested operation has too many matches to return')
    BADQUERYTOOCOMPLEX = ('0x806E0000', 'The requested operation requires too many resources in the server')
    BADNOMATCH = ('0x806F0000', 'The requested operation has no match to return')
    BADMAXAGEINVALID = ('0x80700000', 'The max age parameter is invalid')
    BADSECURITYMODEINSUFFICIENT = ('0x80E60000', 'The operation is not permitted over the current secure channel')
    BADHISTORYOPERATIONINVALID = ('0x80710000', 'The history details parameter is not valid')
    BADHISTORYOPERATIONUNSUPPORTED = ('0x80720000', 'The server does not support the requested operation')
    BADINVALIDTIMESTAMPARGUMENT = ('0x80BD0000', 'The defined timestamp to return was invalid')
    BADWRITENOTSUPPORTED = ('0x80730000', 'The server does not support writing the combination of value')
    BADTYPEMISMATCH = ('0x80740000', "The value supplied for the attribute is not of the same type as the attribute's value")
    BADMETHODINVALID = ('0x80750000', 'The method id does not refer to a method for the specified object')
    BADARGUMENTSMISSING = ('0x80760000', 'The client did not specify all of the input arguments for the method')
    BADNOTEXECUTABLE = ('0x81110000', 'The executable attribute does not allow the execution of the method')
    BADTOOMANYSUBSCRIPTIONS = ('0x80770000', 'The server has reached its maximum number of subscriptions')
    BADTOOMANYPUBLISHREQUESTS = ('0x80780000', 'The server has reached the maximum number of queued publish requests')
    BADNOSUBSCRIPTION = ('0x80790000', 'There is no subscription available for this session')
    BADSEQUENCENUMBERUNKNOWN = ('0x807A0000', 'The sequence number is unknown to the server')
    BADMESSAGENOTAVAILABLE = ('0x807B0000', 'The requested notification message is no longer available')
    BADINSUFFICIENTCLIENTPROFILE = ('0x807C0000', 'The client of the current session does not support one or more Profiles that are necessary for the subscription')
    BADSTATENOTACTIVE = ('0x80BF0000', 'The sub-state machine is not currently active')
    BADALREADYEXISTS = ('0x81150000', 'An equivalent rule already exists')
    BADTCPSERVERTOOBUSY = ('0x807D0000', 'The server cannot process the request because it is too busy')
    BADTCPMESSAGETYPEINVALID = ('0x807E0000', 'The type of the message specified in the header invalid')
    BADTCPSECURECHANNELUNKNOWN = ('0x807F0000', 'The SecureChannelId and/or TokenId are not currently in use')
    BADTCPMESSAGETOOLARGE = ('0x80800000', 'The size of the message specified in the header is too large')
    BADTCPNOTENOUGHRESOURCES = ('0x80810000', 'There are not enough resources to process the request')
    BADTCPINTERNALERROR = ('0x80820000', 'An internal error occurred')
    BADTCPENDPOINTURLINVALID = ('0x80830000', 'The server does not recognize the QueryString specified')
    BADREQUESTINTERRUPTED = ('0x80840000', 'The request could not be sent because of a network interruption')
    BADREQUESTTIMEOUT = ('0x80850000', 'Timeout occurred while processing the request')
    BADSECURECHANNELCLOSED = ('0x80860000', 'The secure channel has been closed')
    BADSECURECHANNELTOKENUNKNOWN = ('0x80870000', 'The token has expired or is not recognized')
    BADSEQUENCENUMBERINVALID = ('0x80880000', 'The sequence number is not valid')
    BADPROTOCOLVERSIONUNSUPPORTED = ('0x80BE0000', 'The applications do not have compatible protocol versions')
    BADCONFIGURATIONERROR = ('0x80890000', 'There is a problem with the configuration that affects the usefulness of the value')
    BADNOTCONNECTED = ('0x808A0000', 'The variable should receive its value from another variable')
    BADDEVICEFAILURE = ('0x808B0000', 'There has been a failure in the device/data source that generates the value that has affected the value')
    BADSENSORFAILURE = ('0x808C0000', 'There has been a failure in the sensor from which the value is derived by the device/data source')
    BADOUTOFSERVICE = ('0x808D0000', 'The source of the data is not operational')
    BADDEADBANDFILTERINVALID = ('0x808E0000', 'The deadband filter is not valid')
    UNCERTAINNOCOMMUNICATIONLASTUSABLEVALUE = ('0x408F0000', 'Communication to the data source has failed. The variable value is the last value that had a good quality')
    UNCERTAINLASTUSABLEVALUE = ('0x40900000', 'Whatever was updating this value has stopped doing so')
    UNCERTAINSUBSTITUTEVALUE = ('0x40910000', 'The value is an operational value that was manually overwritten')
    UNCERTAININITIALVALUE = ('0x40920000', 'The value is an initial value for a variable that normally receives its value from another variable')
    UNCERTAINSENSORNOTACCURATE = ('0x40930000', 'The value is at one of the sensor limits')
    UNCERTAINENGINEERINGUNITSEXCEEDED = ('0x40940000', 'The value is outside of the range of values defined for this parameter')
    UNCERTAINSUBNORMAL = ('0x40950000', 'The value is derived from multiple sources and has less than the required number of Good sources')
    GOODLOCALOVERRIDE = ('0x00960000', 'The value has been overridden')
    BADREFRESHINPROGRESS = ('0x80970000', 'This Condition refresh failed')
    BADCONDITIONALREADYDISABLED = ('0x80980000', 'This condition has already been disabled')
    BADCONDITIONALREADYENABLED = ('0x80CC0000', 'This condition has already been enabled')
    BADCONDITIONDISABLED = ('0x80990000', 'Property not available')
    BADEVENTIDUNKNOWN = ('0x809A0000', 'The specified event id is not recognized')
    BADEVENTNOTACKNOWLEDGEABLE = ('0x80BB0000', 'The event cannot be acknowledged')
    BADDIALOGNOTACTIVE = ('0x80CD0000', 'The dialog condition is not active')
    BADDIALOGRESPONSEINVALID = ('0x80CE0000', 'The response is not valid for the dialog')
    BADCONDITIONBRANCHALREADYACKED = ('0x80CF0000', 'The condition branch has already been acknowledged')
    BADCONDITIONBRANCHALREADYCONFIRMED = ('0x80D00000', 'The condition branch has already been confirmed')
    BADCONDITIONALREADYSHELVED = ('0x80D10000', 'The condition has already been shelved')
    BADCONDITIONNOTSHELVED = (',0x80D20000', 'The condition is not currently shelved')
    BADSHELVINGTIMEOUTOFRANGE = ('0x80D30000', 'The shelving time not within an acceptable range')
    BADNODATA = ('0x809B0000', 'No data exists for the requested time range or event filter')
    BADBOUNDNOTFOUND = ('0x80D70000', 'No data found to provide upper or lower bound value')
    BADBOUNDNOTSUPPORTED = ('0x80D80000', 'The server cannot retrieve a bound for the variable')
    BADDATALOST = ('0x809D0000', 'Data is missing due to collection started/stopped/lost')
    BADDATAUNAVAILABLE = ('0x809E0000', 'Expected data is unavailable for the requested time range due to an un-mounted volume')
    BADENTRYEXISTS = ('0x809F0000', 'The data or event was not successfully inserted because a matching entry exists')
    BADNOENTRYEXISTS = ('0x80A00000', 'The data or event was not successfully updated because no matching entry exists')
    BADTIMESTAMPNOTSUPPORTED = ('0x80A10000', 'The client requested history using a timestamp format the server does not support (i.e requested ServerTimestamp when server only supports SourceTimestamp)')
    GOODENTRYINSERTED = ('0x00A20000', 'The data or event was successfully inserted into the historical database')
    GOODENTRYREPLACED = ('0x00A30000', 'The data or event field was successfully replaced in the historical database')
    UNCERTAINDATASUBNORMAL = ('0x40A40000', 'The value is derived from multiple values and has less than the required number of Good values')
    GOODNODATA = ('0x00A50000', 'No data exists for the requested time range or event filter')
    GOODMOREDATA = ('0x00A60000', 'The data or event field was successfully replaced in the historical database')
    BADAGGREGATELISTMISMATCH = ('0x80D40000', 'The requested number of Aggregates does not match the requested number of NodeIds')
    BADAGGREGATENOTSUPPORTED = ('0x80D50000', 'The requested Aggregate is not support by the server')
    BADAGGREGATEINVALIDINPUTS = ('0x80D60000', 'The aggregate value could not be derived due to invalid data inputs')
    BADAGGREGATECONFIGURATIONREJECTED = ('0x80DA0000', 'The aggregate configuration is not valid for specified node')
    GOODDATAIGNORED = ('0x00D90000', 'The request specifies fields which are not valid for the EventType or cannot be saved by the historian')
    BADREQUESTNOTALLOWED = ('0x80E40000', 'The request was rejected by the server because it did not meet the criteria set by the server')
    BADREQUESTNOTCOMPLETE = ('0x81130000', 'The request has not been processed by the server yet')
    GOODEDITED = ('0x00DC0000', 'The value does not come from the real source and has been edited by the server')
    GOODPOSTACTIONFAILED = ('0x00DD0000', 'There was an error in execution of these post-actions')
    UNCERTAINDOMINANTVALUECHANGED = ('0x40DE0000', 'The related EngineeringUnit has been changed but the Variable Value is still provided based on the previous unit')
    GOODDEPENDENTVALUECHANGED = ('0x00E00000', 'A dependent value has been changed but the change has not been applied to the device')
    BADDOMINANTVALUECHANGED = ('0x80E10000', 'The related EngineeringUnit has been changed but this change has not been applied to the device. The Variable Value is still dependent on the previous unit but its status is currently Bad')
    UNCERTAINDEPENDENTVALUECHANGED = ('0x40E20000', 'A dependent value has been changed but the change has not been applied to the device. The quality of the dominant variable is uncertain')
    BADDEPENDENTVALUECHANGED = ('0x80E30000', 'A dependent value has been changed but the change has not been applied to the device. The quality of the dominant variable is Bad')
    GOODCOMMUNICATIONEVENT = ('0x00A70000', 'The communication layer has raised an event')
    GOODSHUTDOWNEVENT = ('0x00A80000', 'The system is shutting down')
    GOODCALLAGAIN = ('0x00A90000', 'The operation is not finished and needs to be called again')
    GOODNONCRITICALTIMEOUT = ('0x00AA0000', 'A non-critical timeout occurred')
    BADINVALIDARGUMENT = ('0x80AB0000', 'One or more arguments are invalid')
    BADCONNECTIONREJECTED = ('0x80AC0000', 'Could not establish a network connection to remote server')
    BADDISCONNECT = ('0x80AD0000', 'The server has disconnected from the client')
    BADCONNECTIONCLOSED = ('0x80AE0000', 'The network connection has been closed')
    BADINVALIDSTATE = ('0x80AF0000', 'The operation cannot be completed because the object is closed')
    BADENDOFSTREAM = ('0x80B00000', 'Cannot move beyond end of the stream')
    BADNODATAAVAILABLE = ('0x80B10000', 'No data is currently available for reading from a non-blocking stream')
    BADWAITINGFORRESPONSE = ('0x80B20000', 'The asynchronous operation is waiting for a response')
    BADOPERATIONABANDONED = ('0x80B30000', 'The asynchronous operation was abandoned by the caller')
    BADEXPECTEDSTREAMTOBLOCK = ('0x80B40000', 'The stream did not return all data requested (possibly because it is a non-blocking stream)')
    BADWOULDBLOCK = ('0x80B50000', 'Non blocking behaviour is required and the operation would block')
    BADSYNTAXERROR = ('0x80B60000', 'A value had an invalid syntax')
    BADMAXCONNECTIONSREACHED = ('0x80B70000', 'The operation could not be finished because all available connections are in use')